<?php
/**
 * StorePickupTimeForCreate
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\BuClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi. BU. Продавцы
 *
 * Управление продавцами
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\BuClient\Dto;

use \ArrayAccess;
use \Ensi\BuClient\ObjectSerializer;

/**
 * StorePickupTimeForCreate Class Doc Comment
 *
 * @category Class
 * @package  Ensi\BuClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class StorePickupTimeForCreate implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'StorePickupTimeForCreate';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'store_id' => 'int',
        'day' => 'int',
        'pickup_time_code' => 'string',
        'pickup_time_start' => 'string',
        'pickup_time_end' => 'string',
        'cargo_export_time' => 'string',
        'delivery_service' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'store_id' => null,
        'day' => null,
        'pickup_time_code' => null,
        'pickup_time_start' => null,
        'pickup_time_end' => null,
        'cargo_export_time' => null,
        'delivery_service' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'store_id' => false,
        'day' => false,
        'pickup_time_code' => false,
        'pickup_time_start' => false,
        'pickup_time_end' => false,
        'cargo_export_time' => false,
        'delivery_service' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'store_id' => 'store_id',
        'day' => 'day',
        'pickup_time_code' => 'pickup_time_code',
        'pickup_time_start' => 'pickup_time_start',
        'pickup_time_end' => 'pickup_time_end',
        'cargo_export_time' => 'cargo_export_time',
        'delivery_service' => 'delivery_service'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'store_id' => 'setStoreId',
        'day' => 'setDay',
        'pickup_time_code' => 'setPickupTimeCode',
        'pickup_time_start' => 'setPickupTimeStart',
        'pickup_time_end' => 'setPickupTimeEnd',
        'cargo_export_time' => 'setCargoExportTime',
        'delivery_service' => 'setDeliveryService'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'store_id' => 'getStoreId',
        'day' => 'getDay',
        'pickup_time_code' => 'getPickupTimeCode',
        'pickup_time_start' => 'getPickupTimeStart',
        'pickup_time_end' => 'getPickupTimeEnd',
        'cargo_export_time' => 'getCargoExportTime',
        'delivery_service' => 'getDeliveryService'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('store_id', $data, null);
        $this->setIfExists('day', $data, null);
        $this->setIfExists('pickup_time_code', $data, null);
        $this->setIfExists('pickup_time_start', $data, null);
        $this->setIfExists('pickup_time_end', $data, null);
        $this->setIfExists('cargo_export_time', $data, null);
        $this->setIfExists('delivery_service', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets store_id
     *
     * @return int|null
     */
    public function getStoreId()
    {
        return $this->container['store_id'];
    }

    /**
     * Sets store_id
     *
     * @param int|null $store_id ID склада
     *
     * @return $this
     */
    public function setStoreId($store_id)
    {


        /*if (is_null($store_id)) {
            throw new \InvalidArgumentException('non-nullable store_id cannot be null');
        }*/
        $this->container['store_id'] = $store_id;

        return $this;
    }

    /**
     * Gets day
     *
     * @return int|null
     */
    public function getDay()
    {
        return $this->container['day'];
    }

    /**
     * Sets day
     *
     * @param int|null $day День недели (1-7)
     *
     * @return $this
     */
    public function setDay($day)
    {


        /*if (is_null($day)) {
            throw new \InvalidArgumentException('non-nullable day cannot be null');
        }*/
        $this->container['day'] = $day;

        return $this;
    }

    /**
     * Gets pickup_time_code
     *
     * @return string|null
     */
    public function getPickupTimeCode()
    {
        return $this->container['pickup_time_code'];
    }

    /**
     * Sets pickup_time_code
     *
     * @param string|null $pickup_time_code Код времени отгрузки у службы доставки
     *
     * @return $this
     */
    public function setPickupTimeCode($pickup_time_code)
    {


        /*if (is_null($pickup_time_code)) {
            throw new \InvalidArgumentException('non-nullable pickup_time_code cannot be null');
        }*/
        $this->container['pickup_time_code'] = $pickup_time_code;

        return $this;
    }

    /**
     * Gets pickup_time_start
     *
     * @return string|null
     */
    public function getPickupTimeStart()
    {
        return $this->container['pickup_time_start'];
    }

    /**
     * Sets pickup_time_start
     *
     * @param string|null $pickup_time_start Время начала отгрузки
     *
     * @return $this
     */
    public function setPickupTimeStart($pickup_time_start)
    {


        /*if (is_null($pickup_time_start)) {
            throw new \InvalidArgumentException('non-nullable pickup_time_start cannot be null');
        }*/
        $this->container['pickup_time_start'] = $pickup_time_start;

        return $this;
    }

    /**
     * Gets pickup_time_end
     *
     * @return string|null
     */
    public function getPickupTimeEnd()
    {
        return $this->container['pickup_time_end'];
    }

    /**
     * Sets pickup_time_end
     *
     * @param string|null $pickup_time_end Время окончания отгрузки
     *
     * @return $this
     */
    public function setPickupTimeEnd($pickup_time_end)
    {


        /*if (is_null($pickup_time_end)) {
            throw new \InvalidArgumentException('non-nullable pickup_time_end cannot be null');
        }*/
        $this->container['pickup_time_end'] = $pickup_time_end;

        return $this;
    }

    /**
     * Gets cargo_export_time
     *
     * @return string|null
     */
    public function getCargoExportTime()
    {
        return $this->container['cargo_export_time'];
    }

    /**
     * Sets cargo_export_time
     *
     * @param string|null $cargo_export_time Время выгрузки информации о грузе в службу доставки
     *
     * @return $this
     */
    public function setCargoExportTime($cargo_export_time)
    {


        /*if (is_null($cargo_export_time)) {
            throw new \InvalidArgumentException('non-nullable cargo_export_time cannot be null');
        }*/
        $this->container['cargo_export_time'] = $cargo_export_time;

        return $this;
    }

    /**
     * Gets delivery_service
     *
     * @return int|null
     */
    public function getDeliveryService()
    {
        return $this->container['delivery_service'];
    }

    /**
     * Sets delivery_service
     *
     * @param int|null $delivery_service Служба доставки (если указана, то данная информация переопределяет данные дня недели без службы доставки)
     *
     * @return $this
     */
    public function setDeliveryService($delivery_service)
    {


        /*if (is_null($delivery_service)) {
            throw new \InvalidArgumentException('non-nullable delivery_service cannot be null');
        }*/
        $this->container['delivery_service'] = $delivery_service;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


